%% -*- octave -*-
%%
%% produces an Barabási–Albert random graph of order n and attachment-degree m
%%
function G = ba_graph(n, m, matrix_type = "default")
  if (using_sparse_matrix(n, matrix_type))
    G = speye(n);
    E = speye(n);
  else
    G = eye(n);
    E = eye(n);
  endif
  C = ones(n,1);
  V = 1:n;
  G(1,2) = 1;
  G(2,1) = 1;
  for i = 3:n
    P = (G - E)*C;
    P = P / (P'*C);
    for j = discrete_rnd(m, V, P)
	G(i,j) = 1;
	G(j,i) = 1;
    endfor
  endfor
endfunction
