% -*- octave -*-
%
% this function takes an impulse response h and outputs the estimation
% of the spectral gap of the generating system
%
% paramters:
% h : vector containing the impulse response
% 
% output:
% l : 1 - lambda_2
%
function l = gap_estimate_nonzero_b_eigs(h)
  A = kung(h);
  i=0; 
  err=1;
  try
  while (i<3 & err==1) 
    g = flipud(sort(abs(eigs(A,2,"lm"))))(2);
    if (g~=0)
      l=1-g;
      err=0;
    else
      i=i+1;
    endif
  endwhile
  if (err==1)
    printf("warning: eigs does not converge");
    l = 1 - flipud(sort(abs(eig(A))))(2);
  endif
  catch
    printf("error: eigs does not work");
    l = 1 - flipud(sort(abs(eig(A))))(2);
  end_try_catch  

