%% -*- octave -*-
%%
%% H is a graph representing a hypercube of dimension d, and therefore
%% of order n=2^d
%%
%%
%% function H = hypercube(d)
%%   n = 2^d;
%%   tp = 1;
%%   p = [ 1 ];
%%   for i = 2:d
%%     tp = tp * 2;
%%     p = [ p ; tp ];
%%     end
%%     p;
%%     H = zeros(n);
%%     for i = 1:n-1
%%       for j = i+1:n
%% 	if (any(p == bitxor(j-1,i-1))==1)
%% 	  H(i,j) = 1;
%% 	  H(j,i) = 1;
%% 	endif
%%       endfor
%%     endfor
%%
function H = hypercube(d)
  if (d == 0)
    H = [ 0 ];
  else
    H1 = hypercube(d-1);
    E = eye(2^(d-1));
    H = [ H1 E; E H1 ];
  endif
