%% -*- octave -*-
%%
%% this is the main function that computes the spectral gap 
%% from the impulse response 
%%
%% A : transition matrix 
%% T : tolerance: sum of distances distance between the result at the last k iteration and the L privious ones.
%%
%% G : vector containing the estimates of the spectral gap for each vertex
%%
function G = impulse_gap_adaptive(A, Kmin = 0, T=0.000001, L=4)
  n = size(A)(1);
  T = T*n*L;
  A = make_col_stochastic(A);
  b = init_b(n);
  G = [];
  H = [ b ];
  for j = 1:n
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    if (
    Gj = [];
    for i = 1:n
      Gj = [ Gj ; gap_estimate(H(i,:)) ];
    endfor
    if (j > L + 1)
      d = 0;
      for k = 1:L
	d = d + norm(Gj - G(:,k));
      endfor
%%      printf("k=%d d=%f\n", j, d);
      if (d < T)
	return;
      endif
      G = [ G(:,2:L) Gj ];
    else
      G = [ G Gj ];
    endif
  endfor
endfunction
