%% this is the main function that computes the spectral gap from the
%% impulse response.
%%
%% A : transition matrix
%%
%% k : minimum length of the impulse response to use rounded up to the
%% nearest odd number
%%
%% G : vector containing the estimates of the spectral gap for each
%% vertex
%%
function k = impulse_gap_error(A,x)
  
  printf("Computing the gap estrimation whit a long impulse response\n");  
  n = size(A)(1);
  A = make_col_stochastic(A);
  b = init_b_nonzero(n);
  H = impulse_response(A,b,200);
  Gmax = [];
  for i = 1:n
    Gmax = [ Gmax ; gap_estimate(H(i,:)) ];
  endfor
  
  err_index = 2;
  errors = ones(1,5);
  TOL1 = 1e-1;
  TOL2 = 1e-2;
  TOL3 = 1e-3;
  TOL4 = 1e-4;
  TOL5 = 1e-5;
  TOL6 = 1e-6;
  k= zeros(1,6);

  printf("Iteration part\n");
  k(1)=floor(x/2)*2+1;
  H = [ b ];
  for i = (2:k(1))
    b = A*b;
    H = [ H b ];
  endfor
  G = [];
  for i = 1:n
    G = [ G ; gap_estimate(H(i,:)) ];
  endfor
  
  errors(1)= max(abs(Gmax-G))
  bool = errors > TOL1;	

  while(sum(bool)!=0)
    printf("iteration %d\n",k(1));
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    G = [];
    for i = 1:n
      G = [ G ; gap_estimate(H(i,:)) ];
    endfor
    errors(err_index) = max(abs(Gmax-G))
    err_index = err_index+1;
    if (err_index > 5)
      err_index = 1;
    endif
    k(1) = k(1) + 2;
    bool = errors > TOL1;
  endwhile 

    k(2) = k(1);
    bool = errors > TOL2;

  while(sum(bool)!=0)
    printf("iteration %d\n",k(2));
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    G = [];
    for i = 1:n
      G = [ G ; gap_estimate(H(i,:)) ];
    endfor
    errors(err_index) = max(abs(Gmax-G))
    err_index = err_index+1;
    if (err_index > 5)
      err_index = 1;
    endif
    k(2) = k(2) + 2;
    bool = errors > TOL2;
  endwhile  

  k(3) = k(2);
  bool = errors > TOL3;

  while(sum(bool)!=0)
    printf("iteration %d\n",k(3));
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    G = [];
    for i = 1:n
      G = [ G ; gap_estimate(H(i,:)) ];
    endfor
    errors(err_index) = max(abs(Gmax-G))
    err_index = err_index+1;
    if (err_index > 5)
      err_index = 1;
    endif
    k(3) = k(3) + 2;
    bool = errors > TOL3;
  endwhile

  k(4) = k(3);
  bool = errors > TOL4;

  while(sum(bool)!=0)
    printf("iteration %d\n",k(4));
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    G = [];
    for i = 1:n
      G = [ G ; gap_estimate(H(i,:)) ];
    endfor
    errors(err_index) = max(abs(Gmax-G))
    err_index = err_index+1;
    if (err_index > 5)
      err_index = 1;
    endif
    k(4) = k(4) + 2;
    bool = errors > TOL4;
  endwhile

  k(5) = k(4);
  bool = errors > TOL5;

  while(sum(bool)!=0)
    printf("iteration %d\n",k(5));
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    G = [];
    for i = 1:n
      G = [ G ; gap_estimate(H(i,:)) ];
    endfor
    errors(err_index) = max(abs(Gmax-G))
    err_index = err_index+1;
    if (err_index > 5)
      err_index = 1;
    endif
    k(5) = k(5) + 2;
    bool = errors > TOL5;
  endwhile

  k(6) = k(5);
  bool = errors > TOL6;

  while(sum(bool)!=0)
    printf("iteration %d\n",k(6));
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    G = [];
    for i = 1:n
      G = [ G ; gap_estimate(H(i,:)) ];
    endfor
    errors(err_index) = max(abs(Gmax-G))
    err_index = err_index+1;
    if (err_index > 5)
      err_index = 1;
    endif
    k(6) = k(6) + 2;
    bool = errors > TOL6;
  endwhile

  k=k-2;

