%% -*- octave -*-
%%
%% this is the main function that computes the spectral gap 
%% from the impulse response 
%%
%% A : transition matrix 
%% k : length of the impulse response to use
%%
%% G : matrix where column j represents an estimate at time j\in
%% {1,3,5,...,\floor{k/2}*2+1.} Each element i in a column represents
%% the estimate of node i.
%%
function G = impulse_gap_full(A,k)
  n = size(A)(1);
  A = make_col_stochastic(A);
  b = init_b(n);
  G = [];
  H = [ b ];
  k = floor(k/2);
  for j = 1:k
    b = A*b;
    H = [ H b ];
    b = A*b;
    H = [ H b ];
    Gj = [];
    for i = 1:n
      Gj = [ Gj ; gap_estimate(H(i,:)) ];
    endfor
    G = [ G Gj ];
  endfor
endfunction
