%% -*- octave -*-
%%
%% this is the main function that computes the spectral gap 
%% from the impulse response 
%%
%% A : transition matrix 
%% k : length of the impulse response to use
%%
%% G : vector containing the estimates of the spectral gap for each vertex
%%
function G = impulse_gap_gossip(A,k)
  n = size(A)(1);
  b = init_b_real(A);
  Ast = make_col_stochastic(A);
  H = impulse_response(Ast,b,k);
  G = [];
  for i = 1:n
    G = [ G ; gap_estimate(H(i,:)) ];
  endfor
  G = one_round_gossip_vote(A,G);
endfunction
