%% -*- octave -*-
%%
%% this is the main function that computes the spectral gap 
%% from the impulse response 
%%
%% A : transition matrix 
%% k : length of the impulse response to use
%%
%% G : vector containing the estimates of the spectral gap for each vertex
%%
function G = impulse_gap_nonzero_b_with_undetected_failure_with_rank(A,k1,k2,v=1,b=0,stochastic=0)
  n = size(A)(1);
  if(b==0)
    %%printf("init b\n");
    b = init_b_nonzero(n);
  endif
  if (stochastic==0)
    printf("compute stochastic metrics");
    A = make_col_stochastic(A);
  endif
  H = impulse_response_with_undetected_failure(A, b, k1, k2, v);
  G = [];
  for i = 1:n
    if i != v
      G = [ G ; gap_estimate_nonzero_b_with_rank(H(i,:)) ];
    endif
  endfor
endfunction
