%% -*- octave -*-
function E = init_vector_experiment_adaptive(A, m=100, fname="A")
  save(strappend({fname},".mat"){1:1}, "A");
  g = gap(A);
  printf("actual gap = %f\n", g);
  printf("impulse_gap for various init vectors...\n");
  V = impulse_gap_adaptive(A);
  for i = 1:m
    V = [V impulse_gap_adaptive(A)];
  endfor
  printf("\nquantiles...\n");
  Q = transpose(quantile(transpose(V), [0 0.25 0.5 0.75 1]));
  printf("saving graph...\n");
  V = Q(:,3);
  save_graph(strappend({fname},".am"){1:1}, A, V);
  printf("saving sorted results...\n");
  S = sort(Q);
  n = size(S)(1);
  E = [ transpose(linspace(1, n, n)) S ];
  fid = fopen(strappend({fname},".dat"){1:1}, "w");
  fprintf(fid, "# actual=%f\n", g);
  fdisp(fid, E);
  fclose(fid);
endfunction
