%% -*- octave -*-
%%
%% produces the adjacency matrix of a "lollipop" graph with a n-long
%% "stick."
%%
%% The result is a graph of order 2n made of a complete graph of order n
%% connected to a straight line of n vertices.
%%
%% the resulting graph has diameter n+1
%%
function L = lollipop(n)
  L = [ ones(n,n)-eye(n) zeros(n,n); zeros(n,n) zeros(n,n) ];
  for i = (n+1):2*n
    L(i,i-1) = 1;
    L(i-1,i) = 1;
  end
