%% -*- octave -*-
%%
%% takes the (symmetric) adjacency matrix A of an undirected graph, and
%% outputs the transition-probability matrix produced by the
%% Metropolis-hastings algorithm.
%%
function A = metropolis_hastings(A)
  n = size(A)(1);
  for i = 1:n
    A(i,i) = 0;
  endfor
  A = (A != 0);
  d = A*ones(n,1);
  A = A + eye(n);
  for i = 1:(n-1)
    for j = (i+1):n
      if (A(i,j) == 1)
	d_max = max(d(i),d(j));
	A(i,j) = 1/d_max;
	A(j,i) = 1/d_max;
	A(i,i) = A(i,i) - 1/d_max;
	A(j,j) = A(j,j) - 1/d_max;
      endif
    endfor
  endfor

      

