%% -*- octave -*-
%%
%% this is the main function that computes the spectral gap 
%% from the impulse response 
%%
%% A : transition matrix 
%% k : length of the impulse response to use
%%
%% G : vector containing the estimates of the spectral gap for each vertex
%%
function V = one_round_gossip_vote_with_failure(A,G,v)
  n = size(A)(1);
  A(:,v)=zeros(n,1);
  A(v,:)=zeros(1,n);
  V = [];
  G = [G(1:v-1,:) ; 0 ; G(v:size(G)(1),:)];
  for i = 1:n
    if i~=v
      Adj = find(A(i,:));
      Values = [ G(i) ];
      for j = Adj
        if j~=v
          Values = [ Values ; G(j) ];
        endif
      endfor
      V = [ V; median(Values) ];
    endif
  endfor
  %A=(A|eye(n))-eye(n);
  %for i =1:n
  %  if i~=v
  %    [r,c,val]=find(A(i,:)'.* G);
  %    val=[val; G(i)];
  %  endif
  %  V = [ V; median(val) ];
  %endfor 
  
endfunction
