%% -*- octave -*-
%%
%% saves a graph in Tulip's "Adjacency Matrix" format
%% 
%% A is the actual adjacency matrix
%%
%% V is a vector of values associated with vertexes.
%%
function save_dgraph(fname, A, V)
  fid = fopen(fname, "w");
  n = size(A)(1);
  for i = 1:n
    for j = 1:n
      if (i == j)
	fprintf(fid, "%f ", V(i));
      else
	if (A(i,j)==1)
	  fprintf(fid, "@ ");
	else
	  fprintf(fid, "# ");
	endif
      endif
    endfor      
    fprintf(fid, "\n");
  endfor      
  fclose (fid);
endfunction
