%% -*- octave -*-
%%
%% this is the main function that computes the spectral gap 
%% from the impulse response 
%%
%% A : transition matrix 
%% k : length of the impulse response to use
%%
%% G : vector containing the estimates of the spectral gap for each vertex
%%
function [Gtot,etot,stat] = second_eig(A)
Gtot = [];
etot = [];
for k=10:10:200
%for k=100:100:500
  printf("K=%d\n",k);
  n = size(A)(1);
  b = init_b_nonzero(n);
  A = make_col_stochastic(A);
  H = impulse_response(A,b,k);
  G = [];
  ve = [];
  for i = 1:n
    [l,e] = gap_estimate_nonzero_b_get_eig(H(i,:));
    G = [ G ; l ];
    ve = [ve; e];
  endfor
  Gtot = [Gtot G];
  etot = [etot ve];
endfor
stat=[];
realEig = flipud(sort(abs(eigs(A,2,"lm"))))(2); 
printf("realEig = %f\n",realEig);
for i=1:size(etot)(2)
  stat = [stat; max(abs(etot(:,i)-realEig)) min(abs(etot(:,i)-realEig)) abs((sum(etot(:,i))/n)-realEig)];
endfor
endfunction              
