#!/bin/sh
ECHO=/bin/echo
if [ $# -lt 2 ]
then
        ${ECHO} "parameter error: You have $# argument(s) instead of 2."
        ${ECHO} "usage: plotResult out-file-name data-file"
        exit
fi

gnuplot << EOF
set terminal postscript eps enhanced color "Helvetica" 25 #size 4,4
set grid layerdefault
set output "$1.eps"

##
#set size .48,.65 
#set size 0.4,0.55
set size 0.8,1.1
set size square
#set tics scale 0
set tmargin 0
set bmargin 1
set lmargin 0
set rmargin 1
##
unset title
set title offset 0,-1
unset x2tics
unset x2label


set cbtics offset -1
set ytics offset 0.5
set xtics border offset 0,0.5

#set xlabel "k"
#set ylabel "f_t" rotate right
#set label 1 'f_t' at graph -0.14, graph 0.5
#set label 2 "k" at graph 0.5, graph -0.11
set label 1 'f_t' at graph -0.155, graph 0.5
set label 2 "k" at graph 0.5, graph -0.12

set xrange [4:120]
set yrange [4:120]
set cbrange [0:200]

set pm3d map
set palette color model HSV rgbformulae 2,13,10

splot "$2" u 1:2:3 title ""
EOF

